<template>
  <div v-if="brand.name" class="page-folder">
    <Breadcrumb
      :breadcrumb="[
        { name: 'Laptop', url: '/may-tinh-xach-tay' },
        { name: brand.name, url: '/thuong-hieu/' + brand.shared_url },
      ]"
    />
    <section class="folder-show clearfix">
      <ProductBrand :brand="brand" />
      <div class="flex mb56">
        <ProductSidebarFilter
          page="brand"
          :brand="brand"
          :list-filters="listFilters"
          :product_filters="product_filters"
          :option_filters="option_filters"
          :clear-filters="() => clearFilters()"
          :meta="products.meta"
        />
        <ProductList
          :products="products.data"
          :links="products.links"
          :meta="products.meta"
          :get-products="(page) => getProducts(page)"
        />
      </div>
    </section>
  </div>
  <section v-else class="container clearfix">
    <Page404 />
  </section>
</template>

<script>
export default {
  name: 'ProductFolder',
  components: {
    Breadcrumb: () => import('~/components/Breadcrumb'),
    ProductSidebarFilter: () =>
      import('~/components/Products/Category/ProductSidebarFilter'),
    ProductList: () => import('~/components/Products/Category/ProductList'),
    ProductBrand: () => import('~/components/Products/Category/ProductBrand'),
    Page404: () => import('~/components/Articles/Page404'),
  },
  async asyncData({ params, $axios }) {
    const brandSlug = params.brandSlug
    const brand = await $axios.$get('/brand/detail/' + brandSlug)
    const metaseo = await $axios.$get('/brand/seo/' + brandSlug)
    const brands = await $axios.$get('/catalogue/brands')
    const listFilters = await $axios.$get('/catalogue/filters/list')
    const products = await $axios.$post('/catalogue/products/filter?page=1', {
      product_filters: {
        brands: [brand.data.id],
        sub_brands: [],
      },
      option_filters: {
        type: [],
        status: [],
        price_range: [],
        cpu_name: [],
        ram: [],
        storage: [],
        display_size: [],
        display_type: [],
        display_res: [],
        gpu_onboard: [],
        gpu_vram: [],
        weight: [],
      },
    })
    return {
      brands: brands.data,
      brand: brand.data,
      listFilters,
      products,
      product_filters: {
        brands: [brand.data.id],
        sub_brands: [],
      },
      option_filters: {
        type: [],
        status: [],
        price_range: [],
        cpu_name: [],
        ram: [],
        storage: [],
        display_size: [],
        display_type: [],
        display_res: [],
        gpu_onboard: [],
        gpu_vram: [],
        weight: [],
      },
      metaseo: metaseo.data,
    }
  },
  data() {
    return {
      product_filters: {
        brands: [],
        sub_brands: [],
      },
      option_filters: {
        type: [],
        status: [],
        price_range: [],
        cpu_name: [],
        ram: [],
        storage: [],
        display_size: [],
        display_type: [],
        display_res: [],
        gpu_onboard: [],
        gpu_vram: [],
        weight: [],
      },
    }
  },
  watch: {
    product_filters: {
      handler(val) {
        this.getProducts(1)
      },
      deep: true,
    },
    option_filters: {
      handler(val) {
        this.getProducts(1)
      },
      deep: true,
    },
  },
  mounted() {},
  methods: {
    async getProducts(page) {
      const products = await this.$axios.$post(
        '/catalogue/products/filter?page=' + page,
        {
          product_filters: this.product_filters,
          option_filters: this.option_filters,
        }
      )
      this.products = products
    },
    clearFilters() {
      this.product_filters.sub_brands = []
      this.option_filters = {
        type: [],
        status: [],
        price_range: [],
        cpu_name: [],
        ram: [],
        storage: [],
        display_size: [],
        display_type: [],
        display_res: [],
        gpu_onboard: [],
        gpu_vram: [],
        weight: [],
      }
    },
  },
  head() {
    return {
      title: this.metaseo.title,
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: this.metaseo.description,
        },
        {
          name: 'keywords',
          content: this.metaseo.keywords ? this.metaseo.keywords.slice() : '',
        },
      ],
    }
  },
}
</script>
